import { jsx as _jsx } from "react/jsx-runtime";
import 'server-only';
import { DevCycleClientsideProvider } from '../client/DevCycleClientsideProvider';
import { cacheStorageError, getSDKKey, setInitializedPromise, } from './requestContext';
import { initialize, setupContext } from './initialize';
import { getUserIdentity } from './identify';
export const DevCycleServersideProvider = async ({ children, sdkKey, user, options, }) => {
    var _a;
    setupContext(sdkKey, user, options);
    const serverDataPromise = initialize();
    setInitializedPromise(serverDataPromise);
    const identifiedUser = getUserIdentity();
    if (!identifiedUser) {
        throw cacheStorageError();
    }
    // this renders a client component that provides an instance of DevCycle client to client components via context
    // server data is passed to perform bootstrapping of the server's config on clientside
    return (_jsx(DevCycleClientsideProvider, { serverDataPromise: serverDataPromise, serverData: (options === null || options === void 0 ? void 0 : options.enableStreaming) ? undefined : await serverDataPromise, user: identifiedUser, sdkKey: getSDKKey(), enableStreaming: (_a = options === null || options === void 0 ? void 0 : options.enableStreaming) !== null && _a !== void 0 ? _a : false, children: children }));
};
//# sourceMappingURL=DevCycleServersideProvider.js.map